#
# To build specify: --define "kernel VERSION-RELEASE", otherwise it gets build for current kernel
#

%{?!kernel: %define kernel %(/bin/bash -c 'x=`uname -r`; echo ${x%%PAE}')}

%define buildxen 1


# lustre.spec
%define version 1.8.0.1
%define release 0.200907011059%{?dist}

Summary: Lustre File System
Name: lustre
Version: %{version}
Release: %{release}
License: GPL
Group: Utilities/System
Source: lustre-%{version}.tar.gz
URL: http://www.sun.com/software/products/lustre/index.xml
BuildRoot: %{_tmppath}/lustre-%{version}-root
Obsoletes: lustre-lite, lustre-lite-utils, lustre-ldap nfs-utils-lustre
Provides: lustre-lite = %{version}, lustre-lite-utils = %{version}
Provides: lustre-kmod-common = %{version}
# GSS requires this: BuildRequires: pkgconfig, libgssapi-devel >= 0.10

%description
Userspace tools and files for the Lustre file system.

%package devel
Version: %{version}
Release: %{release}
Summary: Lustre filesystem development
License: GPL
Group: Utilities/System
Requires: lustre = %{version}-%{release}

%description devel
Development headers and libraries for the Lustre file system.


%package -n kernel-module-lustre-%{kernel}
Summary:       Lustre filesystem kernel modules
Group:         System Environment/Kernel
License:       GPL
Requires:    kernel = %{kernel}
Requires:    lustre-kmod-common = %{version}
Provides:    lustre-kmod = %{version}
Provides:    kernel-module-lustre = %{version}-%{release}
Provides:    kernel-module
BuildRequires: kernel-devel = %{kernel}

%description -n kernel-module-lustre-%{kernel}
Lustre %{version} filesystem kernel modules for kernel %{kernel}.

%if %buildxen

%package -n kernel-module-lustre-%{kernel}xen
Summary:       Lustre filesystem kernel modules
Group:         System Environment/Kernel
License:       GPL
Requires:    kernel = %{kernel}xen
Requires:    lustre-kmod-common = %{version}
Provides:    lustre-kmod = %{version}
Provides:    kernel-module-lustre = %{version}-%{release}
Provides:    kernel-module
BuildRequires: kernel-xen-devel = %{kernel}

%description -n kernel-module-lustre-%{kernel}xen
Lustre %{version} filesystem kernel modules for kernel %{kernel}xen.

%endif

%ifarch i686

%package -n kernel-module-lustre-%{kernel}PAE
Summary:       Lustre filesystem kernel modules
Group:         System Environment/Kernel
License:       GPL
Requires:    kernel = %{kernel}PAE
Requires:    lustre-kmod-common = %{version}
Provides:    lustre-kmod = %{version}
Provides:    kernel-module-lustre = %{version}-%{release}
Provides:    kernel-module
BuildRequires: kernel-PAE-devel = %{kernel}

%description -n kernel-module-lustre-%{kernel}PAE
Lustre %{version} filesystem kernel modules for kernel %{kernel}PAE.

%endif


%package source
Summary: Object-Based Disk storage driver source
Group: Development/Kernel

%description source
Lustre sources for further development

%package tests
Summary: Lustre testing framework
Group: Development/Kernel
Provides: lustre-tests = %{version}
Requires: lustre = %{version}, lustre-modules = %{version}

%description tests
This package contains a set of test binaries and scripts that are intended
to be used by the Lustre testing framework.

%prep
%setup -qn lustre-%{version}

%build
# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
    RPM_BUILD_NCPUS=$(egrep -c "^cpu[0-9]+" /proc/stat 2>/dev/null || echo 0 :)
    if [ $RPM_BUILD_NCPUS -eq 0 ] ; then
        RPM_BUILD_NCPUS=1
    fi
    if [ $RPM_BUILD_NCPUS -gt 8 ] ; then
        RPM_BUILD_NCPUS=8
    fi
fi

rm -rf $RPM_BUILD_ROOT

mkdir lustre-%{version}
mv * lustre-%{version}/ || :

%if %{buildxen}
mkdir lustre-%{version}xen
cp -r lustre-%{version}/* lustre-%{version}xen/
%endif

%ifarch %{ix86}
mkdir lustre-%{version}PAE
cp -r lustre-%{version}/* lustre-%{version}PAE/
%endif 


%ifarch x86_64
%define myarch x86_64
%else
%define myarch i686
%endif

# Set an explicit path to our Linux tree, if we can.
cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/
./configure '--with-linux=/usr/src/kernels/%{kernel}-%{myarch}/' --with-lustre-hack --with-sockets %{?configure_flags:configure_flags} \
	--sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir}
make -j $RPM_BUILD_NCPUS -s

%if %{buildxen}

cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}xen
./configure '--with-linux=/usr/src/kernels/%{kernel}xen-%{myarch}/' --with-lustre-hack --with-sockets %{?configure_flags:configure_flags} \
        --sysconfdir=%{_sysconfdir} \
        --mandir=%{_mandir} \
        --libdir=%{_libdir}
make -j $RPM_BUILD_NCPUS -s

%endif

%ifarch i686

cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}PAE
./configure '--with-linux=/usr/src/kernels/%{kernel}PAE-%{myarch}/' --with-lustre-hack --with-sockets %{?configure_flags:configure_flags} \
        --sysconfdir=%{_sysconfdir} \
        --mandir=%{_mandir} \
        --libdir=%{_libdir}
make -j $RPM_BUILD_NCPUS -s

%endif

%install

cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/

make install DESTDIR=$RPM_BUILD_ROOT
# hack to avoid changing the libsysio code for "make install"
rm -f $RPM_BUILD_ROOT%{_libdir}/libsysio.a
# Remove ldiskfs module(s) - they are packaged by the ldiskfs .spec.
rm -rf $RPM_BUILD_ROOT/lib/modules/%{kernel}/kernel/fs/lustre-ldiskfs

llog_base=$RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/lustre/obdclass/llog_test
if [ -e ${llog_base}.ko ]; then
  cp ${llog_base}.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}/kernel/fs/lustre
elif [ -e ${llog_base}.o ]; then
  cp ${llog_base}.o $RPM_BUILD_ROOT/lib/modules/%{kernel}/kernel/fs/lustre
fi

# Create the pristine source directory.
cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/
mkdir -p $RPM_BUILD_ROOT/usr/src
rm -f lustre-source
ln -s $RPM_BUILD_ROOT/usr/src lustre-source
make distdir distdir=lustre-source/lustre-%{version}
chmod -R go-w lustre-source/lustre-%{version}

%if %buildxen

cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}xen/

make install DESTDIR=$RPM_BUILD_ROOT

# hack to avoid changing the libsysio code for "make install"
rm -f $RPM_BUILD_ROOT%{_libdir}/libsysio.a
# Remove ldiskfs module(s) - they are packaged by the ldiskfs .spec.
rm -rf $RPM_BUILD_ROOT/lib/modules/%{kernel}xen/kernel/fs/lustre-ldiskfs

llog_base=$RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}xen/lustre/obdclass/llog_test
if [ -e ${llog_base}.ko ]; then
  cp ${llog_base}.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}xen/kernel/fs/lustre
elif [ -e ${llog_base}.o ]; then
  cp ${llog_base}.o $RPM_BUILD_ROOT/lib/modules/%{kernel}xen/kernel/fs/lustre
fi

%endif

%ifarch i686

cd $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}PAE

make install DESTDIR=$RPM_BUILD_ROOT

# hack to avoid changing the libsysio code for "make install"
rm -f $RPM_BUILD_ROOT%{_libdir}/libsysio.a
# Remove ldiskfs module(s) - they are packaged by the ldiskfs .spec.
rm -rf $RPM_BUILD_ROOT/lib/modules/%{kernel}PAE/kernel/fs/lustre-ldiskfs

llog_base=$RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}PAE/lustre/obdclass/llog_test
if [ -e ${llog_base}.ko ]; then
  cp ${llog_base}.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}PAE/kernel/fs/lustre
elif [ -e ${llog_base}.o ]; then
  cp ${llog_base}.o $RPM_BUILD_ROOT/lib/modules/%{kernel}PAE/kernel/fs/lustre
fi

%endif

cd $RPM_BUILD_DIR/lustre-%{version}/

cat >lustre.files <<EOF
%attr(-, root, root) /sbin/mount.lustre
%attr(-, root, root) /usr/sbin/*
%attr(-, root, root) /usr/bin/*

%attr(-, root, root) /usr/share/lustre/*
%attr(-, root, root) %{_mandir}/man?/*

%attr(-, root, root) %{_libdir}/lustre/lc_common
EOF

cat >lustre-devel.files <<EOF
%attr(-, root, root) %{_libdir}/libptlctl.a
%attr(-, root, root) %{_libdir}/liblustreapi.a
%attr(-, root, root) /usr/include/lustre

EOF

if [ -f $RPM_BUILD_ROOT%{_libdir}/libcfsutil.a ] ; then
  echo '%attr(-, root, root) %{_libdir}/libcfsutil.a' >>lustre-devel.files
fi

if [ -f $RPM_BUILD_ROOT%{_libdir}/liblustre.so ] ; then
  echo '%attr(-, root, root) %{_libdir}/liblustre.a' >>lustre-devel.files
  echo '%attr(-, root, root) %{_libdir}/liblustre.so' >>lustre.files
fi

if [ -f $RPM_BUILD_DIR/lustre-%{version}/lustre/utils/libiam.c ] ; then
  echo '%attr(-, root, root) %{_libdir}/libiam.a' >>lustre-devel.files
fi

if [ -d $RPM_BUILD_ROOT%{_libdir}/lustre/snmp ] ; then
  echo '%attr(-, root, root) %{_libdir}/lustre/snmp' >>lustre.files
  echo '%attr(-, root, root) %{_datadir}/lustre/snmp/mibs' >>lustre.files
fi

# Have universal lustre headers 
if [ -f $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/lustre/include/lustre/lustre_idl.h ] ; then
  echo '%attr(-, root, root) /usr/include/linux/lustre_user.h' >>lustre-devel.files
else
  echo '%attr(-, root, root) /usr/include/linux/lustre_idl.h' >>lustre-devel.files
fi

if [ -f $RPM_BUILD_DIR/lustre-%{version}/lustre-%{version}/lustre/include/linux/lustre_types.h ] ; then
  echo '%attr(-, root, root) /usr/include/linux/lustre_types.h' >>lustre-devel.files
fi

echo '%attr(-, root, root) %{_libdir}/lustre/tests/*' >lustre-tests.files
#echo '%attr(-, root, root) /lib/modules/%{kernel}/kernel/fs/lustre/llog_test.*' >>lustre-tests.files
#modules_excludes="llog_test"
modules_excludes=""
if [ -d $RPM_BUILD_ROOT%{_libdir}/lustre/liblustre/tests ] ; then
  echo '%attr(-, root, root) %{_libdir}/lustre/liblustre/tests/*' >>lustre-tests.files
fi

pushd $RPM_BUILD_ROOT >/dev/null
find lib/modules/%{kernel}/kernel -type f -exec echo /{} \; >>$RPM_BUILD_DIR/lustre-%{version}/lustre-modules.files
%if %{buildxen}
find lib/modules/%{kernel}xen/kernel -type f -exec echo /{} \; >>$RPM_BUILD_DIR/lustre-%{version}/lustre-modules-xen.files
%endif
%ifarch i686
find lib/modules/%{kernel}PAE/kernel -type f -exec echo /{} \; >>$RPM_BUILD_DIR/lustre-%{version}/lustre-modules-PAE.files
%endif
popd >/dev/null

%files -f lustre.files

%files devel -f lustre-devel.files

%files -n kernel-module-lustre-%{kernel} -f lustre-modules.files

%if %{buildxen}
%files -n kernel-module-lustre-%{kernel}xen -f lustre-modules-xen.files
%endif

%ifarch i686
%files -n kernel-module-lustre-%{kernel}PAE -f lustre-modules-PAE.files
%endif

%files source
%attr(-, root, root) /usr/src/lustre-%{version}

%files tests -f lustre-tests.files

%post -n kernel-module-lustre-%{kernel}
/sbin/depmod -ae %{kernel} >/dev/null 2>&1 || :

%postun -n kernel-module-lustre-%{kernel}
/sbin/depmod -ae %{kernel} >/dev/null 2>&1 || :

%if %{buildxen}

%post -n kernel-module-lustre-%{kernel}xen
/sbin/depmod -ae %{kernel}xen >/dev/null 2>&1 || :

%postun -n kernel-module-lustre-%{kernel}xen
/sbin/depmod -ae %{kernel}xen >/dev/null 2>&1 || :

%endif

%ifarch i686

%post -n kernel-module-lustre-%{kernel}PAE
/sbin/depmod -ae %{kernel}PAE >/dev/null 2>&1 || :

%postun -n kernel-module-lustre-%{kernel}PAE
/sbin/depmod -ae %{kernel}PAE >/dev/null 2>&1 || :

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%changelog

* Tue Jul 21 2009 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- repackaged Lustre to fit SLC5 kernel-modules schema.

